import { defineConfig } from 'unocss'
import {theme} from './src/config/theme/index'
import { presetUni } from '@uni-helper/unocss-preset-uni'

export default defineConfig({
  presets: [
    presetUni()
  ],
  theme: {
    colors: {
      primary: theme.colors.primary
    }
  },
  // tmui 组件库的类名和unocss有冲突 这里排除一下
  content: {
    pipeline: {
      exclude: [
        // 排除某个文件夹
        'src/uni_modules/tmui/**/*'
      ]
    }
  },
  shortcuts: {
    'flex-center': 'flex justify-center items-center'
  }
})
